@import "variables";

//
// Returns width/height properties
//
// Usage:  .size(10px, 10px)
// Result: width: 10px; height: 10px;
//
@mixin size($X: 100%, $Y: auto) {
  width: $X;
  height: $Y;
}

//
// Returns font-size: XXpx;
//
// Usage:  @include fontSize(32px);
// Result: font-size: 32px;
//
@function calculateRem($size) {
  $remSize: $size / 16px;
  @return #{$remSize}rem;
}

@mixin fontSize($size) {
  font-size: $size; //Fallback in px
  font-size: calculateRem($size);
}

//
// Changes the color of Input placeholders
// Usage:  .placeholder(#000)
// Result: Black Placeholder
//
@mixin placeholder($color: #000) {
  &::-webkit-input-placeholder { /* Chrome/Opera/Safari */
    color: $color;
  }
  &::-moz-placeholder { /* Firefox 19+ */
    color: $color;
  }
  &:-ms-input-placeholder { /* IE 10+ */
    color: $color;
  }
  &:-moz-placeholder { /* Firefox 18- */
    color: $color;
  }
}

@mixin gradientDarkToLight($degrees: 45deg, $opacity: 1) {
  /* Permalink - use to edit and share this gradient: http://colorzilla.com/gradient-editor/#59b4e8+0,91daff+100 */
  background: #59b4e8; /* Old browsers */
  background: -moz-linear-gradient($degrees, rgba($cPrimary, $opacity) 0%, rgba($cSecondary, $opacity) 100%); /* FF3.6-15 */
  background: -webkit-linear-gradient($degrees, rgba($cPrimary, $opacity) 0%, rgba($cSecondary, $opacity) 100%); /* Chrome10-25,Safari5.1-6 */
  background: linear-gradient($degrees, rgba($cPrimary, $opacity) 0%, rgba($cSecondary, $opacity) 100%); /* W3C, IE10+, FF16+, Chrome26+, Opera12+, Safari7+ */
  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#59b4e8', endColorstr='#91daff', GradientType=1); /* IE6-9 fallback on horizontal gradient */
}

@mixin gradientLightToDark($degrees: 45deg, $opacity: 1) {
  /* Permalink - use to edit and share this gradient: http://colorzilla.com/gradient-editor/#91daff+0,59b4e8+99 */
  background: #91daff; /* Old browsers */
  background: -moz-linear-gradient($degrees, rgba($cSecondary, $opacity) 0%, rgba($cPrimary, $opacity) 99%); /* FF3.6-15 */
  background: -webkit-linear-gradient($degrees, rgba($cSecondary, $opacity) 0%, rgba($cPrimary, $opacity) 99%); /* Chrome10-25,Safari5.1-6 */
  background: linear-gradient($degrees, rgba($cSecondary, $opacity) 0%, rgba($cPrimary, $opacity) 99%); /* W3C, IE10+, FF16+, Chrome26+, Opera12+, Safari7+ */
  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#91daff', endColorstr='#59b4e8', GradientType=1); /* IE6-9 fallback on horizontal gradient */
}

//
// Returns all styles and transforms needed for the mobile menu button
//
// Usage:  #navbtn{ .menu(30px, auto, 0 10px, #fff, 5px, 30px, 10px); }
// Result: Animated mobile menu button (3 lines to X)
//
@mixin menu($height: 45px, $width: auto, $padding: 0 15px, $color: #333, $lHeight: 10px, $lWidth: 48px, $lGap: 10px) {
  padding: $padding;
  height: $height;
  width: $width;
  transition: 0.3s;
  -webkit-appearance: none;
  -moz-appearance: none;
  appearance: none;
  border: none;
  cursor: pointer;
  display: -webkit-flex;
  display: -ms-flexbox;
  display: flex;
  -webkit-justify-content: center;
  -ms-flex-pack: center;
  justify-content: center;
  -webkit-align-items: center;
  -ms-flex-align: center;
  align-items: center;
  -webkit-user-select: none;
  -moz-user-select: none;
  -ms-user-select: none;
  user-select: none;
  background: transparent;
  outline: none;
  -webkit-tap-highlight-color: transparent;
  > * {
    display: block;
  }
  &:hover, &:focus {
    outline: none;
  }
  &::-moz-focus-inner {
    border: 0;
  }
  .menuLines {
    display: inline-block;
    height: $lHeight;
    width: $lWidth;
    transition: 0.3s;
    background: $color;
    position: relative;
    &::before, &::after {
      display: inline-block;
      height: $lHeight;
      transition: 0.3s;
      background: $color;
      content: '';
      position: absolute;
      left: 0;
      -webkit-transform-origin: 2.85714px center;
      transform-origin: 2.85714px center;
      width: 100%;
    }
    &::before {
      top: $lGap;
    }
    &::after {
      top: -$lGap;
    }
  }
  &.menuTransform .menuLines {
    background: transparent;
    &::before, &::after {
      width: $lWidth;
      -webkit-transform-origin: 50% 50%;
      transform-origin: 50% 50%;
      top: 0;
    }
    &::before {
      -webkit-transform: rotate3d(0, 0, 1, 45deg);
      transform: rotate3d(0, 0, 1, 45deg);
    }
    &::after {
      -webkit-transform: rotate3d(0, 0, 1, -45deg);
      transform: rotate3d(0, 0, 1, -45deg);
    }
  }
  .menuVisuallyhidden {
    border: 0;
    clip: rect(0 0 0 0);
    height: 1px;
    margin: -1px;
    overflow: hidden;
    padding: 0;
    position: absolute;
    width: 1px;
    &:active, &:focus {
      clip: auto;
      height: auto;
      margin: 0;
      overflow: visible;
      position: static;
      width: auto;
    }
  }
}
